/*
 *        html
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "compile.h"
#include "strutils.h"
#include "proto.h"
#include "alfa.h"

extern int mkdir (char *path, unsigned mode);

extern char OutPath[];
extern alfacoll Srg1,Srg2,Subst;

FILE *findex, *out, *ir;
int rlnum;

typedef char *tsplit[256];
tsplit esplit, rsplit, alist1, alist2;
tsplit *sp, *alist;

char *words[256];

FILE *rpat, *irpat;
int text;

int searchsp(char *name,tsplit sp) {
  int i;

  for (i=0; sp[i]; i++)
    if (strcmp(name,sp[i])==0) return i+1;
  return 0;
} //searchsp

int checkword(char *rword) {
  int i;

  for (i=0; words[i]; i++)
    if (strcmp(words[i],rword)==0) return 1;
  return 0;
} //checkword

int begin_ir (char *pref, char *pattern, char *rletter) {
  int i;
  char path[256];

  strcpy(path,OutPath);
  strcat(path,"RIND/");
  strcat(path,pref);
  strcat(path,rletter);
  strcat(path,".html");
  ir=fopen(path,"wb");
  if (ir==NULL) return 0;

  irpat=prologue(ir,pattern,rletter);
  fprintf(ir,"<hr /><small><b>\r\n");

  for (i=0; i<255 && (*alist)[i]; i++) {
    char *p, *pp;
    char str1[MAXLEN],str2[MAXLEN];

    p=pp=(*alist)[i];

    while (*pp && *pp!=' ') pp++;
    strncpy(str1,p,pp-p);
    str1[pp-p]=0;
    while (*pp==' ') pp++;

    p=pp;
    while (*pp && *pp!=' ') pp++;
    strncpy(str2,p,pp-p);
    str2[pp-p]=0;

    //if (str2[0]=='' || str2[0]=='' || str2[0]=='') continue;

    if (strcmp(rletter,str1)) {
      if (strcmp(pref,"ie_")==0)
        fprintf(ir,"<a href=\"ie_%s.html\" target=\"left\">",str1);
      else if (strcmp(pref,"ir_")==0)
        fprintf(ir,"<a href=\"ir_%s.html\" target=\"left\">",str1);
    }
    else
      rlnum=i;
    fputStrUni(ir,str2);
    if (strcmp(rletter,str1))
      fprintf(ir,"</a>");
    fprintf(ir,"\r\n");
  } //for

  fprintf(ir,"</b></small>\r\n");
  fprintf(ir,"<hr />\r\n");

  //fprintf(ir,"<table border=\"0\" width=\"180\" align=\"center\" cellpadding=\"1\">\r\n");
  fprintf(ir,"<tt>\r\n");
  return 1;
} //begin_ir

void end_ir() {
  fprintf(ir,"</tt>\r\n");
  //fprintf(ir,"</table>\r\n");
  fprintf(ir,"<hr />\r\n");
  fprintf(ir,"<div class=\"revo\">\n");
  fprintf(ir,"<a target=\"revo\" href=\"../Revo/\">Reta Vortaro</a>\n");
  fprintf(ir,"</div>\n");
  fprintf(ir,"</body>\r\n");
  fprintf(ir,"</html>\r\n");
  fclose(ir);
} //end_ir

void skipletters (char *pref, char *pattern, char *rletter) {
  char ll[80];
  int i;

  strcpy(ll,rletter);
  strcat(ll," ");
  for (i=rlnum+1; i<256 && (*alist)[i] && strncmp(ll,(*alist)[i],strlen(ll)); i++) {
    char *p, *pp;
    char str1[MAXLEN];

    p=pp=(*alist)[i];
    while (*pp && *pp!=' ') pp++;
    strncpy(str1,p,pp-p);
    str1[pp-p]=0;

    begin_ir(pref,pattern,str1);
    end_ir();
  }
} //skipletters

void make_index() {
  char rus[80], rus0[80], esp[80], rword[80], eword[80], addr[80], letter[3];
  char path[256], curpath[256], ref[256];
  char s[1024],ss[256];
  char rletter[80], r3letter[80], r3letterold[80], rl[80];
  char rr1l[80],rr2l[80],rr3l[80];
  int pezo, first, beg, begw, colon, tdcnt;
  int alfanum;
  int newfile, marku;
  char *p,*pp;
  int a,i,n, nw;
  FILE *f;
  char pat[256];
  alfacoll *al,*al0;

  load_list("iesplit.cfg",esplit,256);
  load_list("irsplit.cfg",rsplit,256);
  load_list("iexcl.cfg",words,256);

  load_list("srg1.cfg",alist1,256);
  load_list("srg2.cfg",alist2,256);

  strcpy(s,OutPath);
  strcat(s,"RIND/");
  mkdir(s,0777);

  al0=NULL;

  r3letter[0]=r3letterold[0]=rletter[0]=0;
  rword[0]=0; eword[0]=0; first=1;
  findex=fopen("rindex.ind","r");
  while (!feof(findex)) {
    fgets(s,sizeof(s)-1,findex);
    p=strchr(s,'\n');
    if (p) *p=0;
    p=strchr(s,'\r');
    if (p) *p=0;

    p=s;
    if (*p==0) break;

    while (*p && *p==' ') p++;
    alfanum=(*p=='1')?1:2;
    while(*p && *p!=' ') *p++;
    if (*p==0) break;
    while (*p && *p==' ') p++; // 0-  ( )

    while(*p && *p!=' ') *p++;
    if (*p==0) break;
    while (*p && *p==' ') p++; // 1-  ()

    pp=ss;
    while (*p && *p!=' ') // 2-   ss
      *pp++ = *p++;
    *pp=0;
    if (*p==0) break;
    sscanf(ss,"%d",&pezo); //   2- 

    while (*p && *p==' ') p++;
    if (*p==0) break;
    while(*p && *p!=' ') *p++; // 3- 
    if (*p==0) break;

    while (*p && *p==' ') p++;
    if (*p!='<') continue;
    p++;
    pp=addr;
    while(*p && *p!='>') // 4 <>  addr
      *pp++ =  *p++;
    *pp=0;
    p++;

    while (*p && *p==' ') p++;
    pp=rus;
    while(*p && *p!=' ') // 5-   rus
      *pp++ = *p++;
    *pp=0;
    p++;

    while (*p && *p==' ') p++;
    if (*p!='<') continue;
    p++;
    pp=esp;
    while(*p && *p!='>') // 6 <>  esp
      *pp++ =  *p++;
    *pp=0;

    while (rep(esp,"_"," "));
    while (rep(rus,"_"," "));
    while (rep(rus,"#","-"));
    while (rep(rus,"--","&ndash;"));
    p=strchr(esp,'>');
    if (p) *p=0;
    p=esp;
    if (*p=='<') p++;
    if (*p==0) continue;

    //if (strncmp(rus,"-",1)==0) continue;

    marku=0;
    newfile=0;

    al=NULL;
    if (alfanum==1) {
      al=&Srg1;
      alist=&alist1;
      sp=&esplit;
    }
    else {
      al=&Srg2;
      alist=&alist2;
      sp=&rsplit;
    }

    pp=rus;
    while (*pp=='-') pp++;

    if (!isInAlfa(pp,(alfanum==1)?&Srg1:&Srg2)) continue;
    if (al!=al0) {
      fprintf(stderr,"%s   *** Indeksoj de %s ***\n",
        al0?"\n":"",
        (al==&Srg1)?"fontolingvo":"cellingvo");
      rlnum=0;
    }
    al0=al;
    toNKey(pp,al,1,rl,NULL);

    if (strcmp(rletter,rl)) {
      if (!first)
        end_ir();

      strcpy(rletter,rl);

      if (al==&Srg1) {
        skipletters("ie_","ie.pat",rletter);
        begin_ir("ie_","ie.pat",rletter);
      }
      else {
        skipletters("ir_","ir.pat",rletter);
        begin_ir("ir_","ir.pat",rletter);
      }
      if (ir==NULL) continue;

      tdcnt=0;
      newfile=1;
      marku=1;
    } //if

    r3letter[0]=0;
    strcpy(rus0,rus);
    while (rep(rus0,"-",""));
    toNKey(rus0,al,3,r3letter,NULL);
    //while (rep(r3letter,"-","_"));
    while (rep(r3letter," ","_"));

    if (strcmp(r3letter,r3letterold)) {
      strcpy(r3letterold,r3letter);
      marku=1;
      if (searchsp(r3letter,*sp))
        newfile=1;
    }

    if (newfile) {
      if (!first) {
        epilogue(out,rpat,"");
        fclose(out);
      }
      strcpy(path,OutPath);
      strcat(path,"RIND/");
      if (al==&Srg1)
        strcpy(curpath,"e_");
      else if (al==&Srg2)
        strcpy(curpath,"r_");
      else continue;
      if (searchsp(r3letter,*sp))
        strcat(curpath,r3letter);
      else
        strcat(curpath,rletter);
      strcat(curpath,".html");
      strcat(path,curpath);

      out=fopen(path,"wb");
      if (out==NULL) continue;
      beg=1; begw=1;

      //proto(out,"pro_r.pat",rletter);
      rpat=prologue(out,"r.pat",rletter);
      fprintf(stderr,"%s ",r3letter);
    } //if

    //getaddr(addr,p); //   esp
    while (rep(addr,"'",""));
    while (rep(addr,"-","_0"));
    {
      char *pp=strchr(addr,',');
      if (pp) *pp=0;
    }
    if (strcmp(rword,rus)) {
      strcpy(rword,rus);
      begw=1;
      if (!beg)
        fprintf(out,"\r\n<br />\r\n");
      if (marku) {
        /*if (tdcnt%4==0) {
            if (tdcnt) fprintf(ir,"</tr>\r\n");
            fprintf(ir,"<tr>\r\n");
          }*/
        fprintf(out,"<a name=\"%s\"></a>\r\n",r3letter);
        fprintf(ir,"<a href=\"%s#%s\"><b>",curpath,r3letter);

        toNKey(rus0,al,1,NULL,rr1l);
        while (rep(rr1l," ","_"));
        toNKey(rus0,al,2,NULL,rr2l);
        while (rep(rr2l," ","_"));
        toNKey(rus0,al,3,NULL,rr3l);
        while (rep(rr3l," ","_"));
        fputStrUni(ir,rr1l);
        if (strlen(rr2l)>strlen(rr1l))
          fputStrUni(ir,rr2l+strlen(rr1l));
        else
          fprintf(ir,"&nbsp;");
        fprintf(ir,"</b>");
        if (strlen(rr3l)>strlen(rr2l))
          fputStrUni(ir,rr3l+strlen(rr2l));
        else
          fprintf(ir,"&nbsp;");
        fprintf(ir,"</a>\r\n");
        //tdcnt++;
      } //if

      if (strcmp(rus,p)==0)
        colon=1;
      else if (pezo<9998 || !checkword(rword)) {
        if (pezo==9999)
          fprintf(out, "<small>");
        else if (pezo==9998)
          fprintf(out, "<i>");
        fputStrUni(out,rus);
        fprintf(out, ":");
        if (pezo==9999)
          fprintf(out,"</small>");
        else if (pezo==9998)
          fprintf(out, "</i>");
        fprintf(out, "\r\n");
        colon=0;
      } //if
      eword[0]=0;
    } //if

    if (begw) nw=1;

    if (pezo<9998 || !checkword(rword))
    if (strcmp(eword,p)) {
      char *p0,*p1;

      strcpy(eword,p);
      p1=p;
      while (p1) {
        if (!begw) {
          if (colon)
            fprintf(out,":\r\n");
          else
            fprintf(out,",\r\n");
          colon=0;
        }
        begw=0;

        p0=strchr(p1,',');
        if (p0)
          *p0++=0;

        if (pezo==9999)
          fprintf(out, "<small>");
        else if (pezo==9998)
          fprintf(out, "<i>");
        fprintf(out,"<a href=\"../%s\">",addr);
        fputStrUni(out,p1);
        fprintf(out,"</a>");
        if (pezo==9999)
          fprintf(out, "</small>");
        else if (pezo==9998)
          fprintf(out, "</i>");
        p1=p0;
        nw++;
      } //while
    } //if
    first=0; beg=0;
    /*if (nw>10)
         printf("nw=%d '%s'\r\n",nw,rword);*/
  } //while

  epilogue(out,rpat,"");
  fclose(out);

  fprintf(ir,"</tt>\r\n");
  //fprintf(ir,"</table>\r\n");

  epilogue(ir,irpat,"");
  fclose(ir);

  fclose(findex);
  unlink("rindex.ind");
  fprintf(stderr,"\n");
  //fprintf(stderr,"\r                                \r");
} //make_index
